/* $Id: compadvcriteria.js,v 1.4 2009/05/04 08:00:44 hanifa Exp $ */
function CriteriaComp(tableBodyId)
{
this.id = tableBodyId;
this.defn = new Object();
this.tableBody = document.getElementById(tableBodyId);
this.tableBody.CROBJ = this;
this.rowId = 0;
CriteriaComp_MODELS[this.id] = this;

this.addOptions = function(selectEl,optionVals,optionDisplayVals)
{
	for(var i =0; i < optionVals.length; i++)
	{
		var objOption=document.createElement("OPTION");
		objOption.value = optionVals[i];
		objOption.innerHTML= optionDisplayVals[i];
		selectEl.appendChild(objOption);
	}   
}

this.addRow = function(curDefn)
{
	var trRow = document.createElement("tr");
	trRow.className ="criteriaRowTR";
	trRow.ROWIDX = ++this.rowId;
	trRow.CROBJ = this;
	this.tableBody.appendChild(trRow);
	this.genCriteriaCr(this.rowId,trRow,curDefn);
}

this.genCriteriaCr = function(rowId,trRow,curDefn)
{
	CriteriaComp.removeAllChilds(trRow);
	CriteriaComp.appendInnerHTML(document.getElementById("LOGICALOP_DEF"),trRow);
	CriteriaComp.appendInnerHTML(document.getElementById("CONFIG_LABEL"),trRow);
	CriteriaComp.appendInnerHTML(document.getElementById("CONDITION_DEF"),trRow);
	CriteriaComp.appendInnerHTML(document.getElementById("CLOSE_ROW"),trRow);
	
	var values = new Object();
	if(curDefn != null)
	{
		CriteriaComp.update(curDefn,values);
	}
	CriteriaComp.update({ROWIDX:rowId},values);
	
	var idEls = CriteriaComp.getChildElsWithAttr(trRow,"name","*");
	for(var i =0; i  < idEls.length; i++)
	{
		var curEl = idEls[i];
		var name = curEl.getAttribute("name");
		
		if(curEl.nodeName == "SELECT")
		{
			var optVal = values[name + "_OPTVAL"]; 
			if(optVal != null)
			{
				this.addOptions(curEl,optVal,(values[name + "_OPTDISP"] != null)?values[name + "_OPTDISP"]:optVal);
			}
		}
		
		var curVal = values[name];
		var type = curEl.type;
		if(curVal != null)
		{
			if((type == "radio") || (type == "checkbox"))
			{
				curEl.checked = (curVal == curEl.value);
			}
			else if((curEl.nodeName =="DIV") || (curEl.nodeName =="SPAN"))
			{
				curEl.innerHTML=curVal;
			}
			else
			{
				curEl.value = curVal;
			}
		}
		
		if((curEl.getAttribute("hideforfirst") == "true") && (rowId == 1))
		{

			if(curEl.getAttribute("isselectbox") == "true")
			{
				curEl.style.display= "none";
			}
			else
			{
				curEl.disabled = "true";
				if(name == "REMOVEROW")
				{
					curEl.style.cursor = "default";
					curEl.className = "remove_dadvanced";
				}
			}

		}
		//if(name== "COLVALUEID")
		//{
		//	curEl.id="COLVALUE_" + rowId + "_DIV";
		//}
		if(curEl.getAttribute("fixedname") != "true")
		{
			curEl.setAttribute("name",name + "_" + rowId);
			curEl.setAttribute("id",name + "_" + rowId);
		}
		//curEl.setAttribute("origname",name);
	}
}

this.deleteRow = function(el,trRow)
{
    trRow.parentNode.removeChild(trRow);
}

/*this.getAsParams = function(names)
{
	var params="";
	for(var i =0; i < names.length; i++)
	{
		var els = CriteriaComp.getChildElsWithAttr(this.tableBody,"origname",names[i]);
		for(var j =0;  j < els.length; j++)
		{
			params += els[j].getAttribute("name") + "=" +els[j].value + "&";
		}        
	}
	return params.substring(0,params.length -1);
}*/

}

CriteriaComp_MODELS= new Object();
CriteriaComp.getInstanceFor = function(id)
{
	return CriteriaComp._MODELS[id];
}

CriteriaComp.update = function(srcObj,destObj)
{
	for(var i in srcObj)
	{
		destObj[i] = srcObj[i];
	}
}

CriteriaComp.invoke = function(selectCol)
{  
	var trRow = CriteriaComp.getInstanceFor(selectCol);
	trRow.CROBJ[selectCol.getAttribute("function")](selectCol,trRow);
}

CriteriaComp.getInstanceFor = function(el)
{
	var parEl = el;
	while((parEl != null) && (parEl.CROBJ == null))
	{
		parEl = parEl.parentNode;
	}
	return parEl;
}

CriteriaComp.getChildElsWithAttr = function(parentEl,attrName,attrValue)
{
	var childNodes = parentEl.getElementsByTagName("*");
	return this.filterElements(childNodes,null,attrName,attrValue);
}

CriteriaComp.filterElements = function(elList,elType,attrName,attrValue)
{
	var filteredList = new Array();
	var j = 0;
	for(var i =0;i < elList.length ; i++)
	{
		if((elType == null) || (elList[i].nodeName == elType))
		{
			if((attrName == null)|| (elList[i].getAttribute(attrName) == attrValue)
			|| ((attrValue == "*") &&(elList[i].getAttribute(attrName) != null)))
			{
				filteredList[j++] = elList[i];
			}
		}
	}
return filteredList;
}

CriteriaComp.removeAllChilds = function(srcEl)
{
	childNodes = LangUtils.cloneArray(srcEl.childNodes); 
	for(var i =0;i < childNodes.length;i++)
	{
		srcEl.removeChild(childNodes[i]);
	} 
}

CriteriaComp.appendInnerHTML = function(srcEl,destEl)
{
	srcEl = srcEl.cloneNode(true);
	childNodes = LangUtils.cloneArray(srcEl.childNodes); 
	for(var i =0;i < childNodes.length;i++)
	{
		destEl.appendChild(childNodes[i]);
	} 
}

CriteriaComp.handleNull = function(comparatorCombo)
{
	var trEl = CriteriaComp.getInstanceFor(comparatorCombo);
	var elList = CriteriaComp.getChildElsWithAttr(trEl,"nullhide","*");
	for(var i =0; i < elList.length; i++)
	{
		elList[i].style.display = (comparatorCombo.value >= 30 && comparatorCombo.value < 40)? "none":"";
	}
}
